      SUBROUTINE surface_nature(obliquit,qsurf,qsurfliquid
     &   ,qsurfsnow,rnat,oceanarea)
      IMPLICIT none

!==================================================================
!     
!     Purpose
!     -------
!     Defines a few things
!     
!     Authors
!     ------- 
!     B. Charnay (2010)
!     
!     Called by
!     ---------
!     physiq.F
!     
!     Calls
!     -----
!     none
!
!     Notes
!     -----
!     rnat is terrain type: 0-ocean; 1-continent; 2-continental ice
!     
!==================================================================

#include "dimensions.h"
#include "dimphys.h"
#include "comcstfi.h"
#include "callkeys.h"
#include "tracer.h"
#include "fisice.h"
#include "comgeomfi.h"
#include "surfdat.h"
#include "comsoil.h"

	REAL qsurf(ngridmx,nqmx),ps(ngridmx)
	REAL qsurfliquid(ngridmx)
	REAL qsurfsnow(ngridmx)
	INTEGER iq, ig
	INTEGER rnat(ngridmx)
 	REAL oceanarea
	REAL obliquit

	do ig=1,ngridmx
           rnat(ig)=1
           dryness(ig)=1        !(coefficient for evaporation)
           if (inertiedat(ig,1).gt.1E4) then
              rnat(ig)=0
           end if
	end do

! surface of all the oceans
        
        oceanarea=0.
	do ig=1,ngridmx
           if (rnat(ig).eq.0)then
              oceanarea=oceanarea+area(ig)
           end if
	enddo

        return
        end

